import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocInstructions {

    public DocInstructions() {}


    public static void setup(DocumentCanvas D) {
    
	String S="Fundamental Lemma of Sydler\n";
	S=S+"by Rich Schwartz\n";
	S=S+"program started: 10 years ago\n";
	S=S+"Last updated:  7 Oct 2019\n";

	S=S+"\n\nQUICK NOTES:\n";

	S=S+"\nYou can drag the text on this window to see more of it.\n\nThis window is resizeable, as is the plot window.\n\nThis program works best with a 3 button mouse, but you can also use the keys z,x,c to simulate a 3 button mouse.\n\nThe complicated window is the control panel.\n\nThe black window is the plot window.  You use buttons 1,3 (or keys z,c) to zoom in and out of the picture.";

	S=S+"\n\nPROGRAM PURPOSE:\n\n";

	
	S=S+"Two polyhedra P,Q are dissection equivalent if one can cut P into finitely many pieces and then reassemble these pieces, using isometric copies, into Q.  This turns out to be an equivalence relation. The Dehn-Sydler Theorem says that two polyhedra are dissection equivalent if and only if they have the same Dehn Invariant.\n\nThis applet explains a key lemma in the proof of the Dehn-Sydler Theorem.  You can drag the text down in this window to see more of it.";
	S=S+"\nLet P denote the the abelian group of formal integer sums of polyhedra. Let J be the subgroup generated by the relations coming from polyhedral dissections, and also the formal sums of prisms.  The Fundamental Lemma of Sydler establishes a certain relation in P/J, namely \n\nT(a,b)+T(ab,c)=T(a,c)+T(ac,b)\n\nfor any a,b,c in (0,1). Here T(a,b) is the name of a certain orthoscheme.  An orthoscheme is a tetrahedron made from taking the convex hull of points of the form \n\n(0,0,0)  (x,0,0)  (x,y,0)  (x,y,z).\n\nThe orthoscheme T(a,b) has parameters\n\n x=a'   y=a'b'   z=b'\n\nwith a'=sqrt[(1/a)-1], etc.\n\nThe other orthoschemes in the equation have similar descriptions.  One computes that both sides of the equation have the same Dehn invariant, so the relation is implied by the Dehn-Sydler Theorem.  At the same time, this relation is the key to proving the Dehn-Sydler Theorem.";

	
	S=S+"\n\nCAVEAT:\n\n";

	S=S+"The dissections in the program really only work for an open set of parameters in [0,1]^3.  This is enough to establish the main result, thanks to analytic continuation.  What happens for some parameter choices is that some of the auxiliary polyhedra used in the decompositions break down.";


	S=S+"\n\nLAYOUT OF THE PROGRAM:\n\n";

	S=S+"The three red sliders let you control the values of the parameters a,b,c.  The list of points A,B,...,N,O, which depend on the parameters, are all the vertices of all the polyhedra involved in the proof.  You can click on the black buttons besides these points to see them displayed in the black window.  The various polyhedra involved all have these points as vertices.  Each polyhedron is named by its vertices and also is given an auxiliary name.  For instance:\n\nT(a,b)=O1=ABCD\nT(a,c)=O2=ABEF\nT(ab,c)=O3=ADMN\nT(ac,b)=O4=AFLK\n\nSo, the Fundamental Lemma of Sydler says that\n\nO1+O3=O2+O4\n\nYou can click on the black boxes beside any given polyhedron and see what it does.  The polyhedra are classified into various types: orthoschemes, pseudoprisms, etc  Each control panel lets you display different kinds of polyhedra.  The proof establishes (*) by doing some algebra in the group P/J.  The first 4 lines of the blue decomps window illustrate the dissection equations:\n";

	S=S+"\n1. O2+P5+E5+E6=O1+P1+P2+E2+E3+E4+E6";
	S=S+"\n2. O4=P3+E5";
	S=S+"\n3. P4+E2+E7+E8=P6+E2+E3+E7+E8";
        S=S+"\n4. O3=E1+E4";
	S=S+"\n\nIn each of the 4 equations, both sides are dissections of the same convex polyhedron.";

	S=S+"\n\nThe P terms are pseudoprisms, which (as we discuss below) vanish in P/J.  So, the equations above simplify to\n";

	S=S+"\n1*. O2+E6=O1+E2+E3+E4";
	S=S+"\n2*. O4=E6";
	S=S+"\n3*. E1=E2+E3";
        S=S+"\n4*. O3=E1+E4";

        S=S+"\n\nPlugging (2*) into (1*) gives\n\nO2+O4=O1+(E2+E3)+E4\n\nPlugging in (3*) gives\n\nO2+O4=O1+(E1+E4).\n\nPlugging in (4*) gives O2+O4=O1+O3.  That is the end of the proof.";
	

	S=S+"\n\nTECHNICAL POINTS:\n\n";
	S=S+"A prism is the product of a polygon and an interval.  By definition, prisms are 0 in P/J.  If you turn on the `partner pseudo' button you can see that each pseudoprism has a complemtary pseudoprism which is just a rotated copy, so that the union is a prism.  In other words A+A is trivial in P/J for each pseudoprism A.  Since P/J has the structure of a real vector space, A=0.  That is why we can freely add and subtract the pseudoprisms from the equations above.";
	S=S+"\n\nNow we discuss some geometric features of the points A,B,...,N,O are constructed.  It is very hard to see how these geometric features contribute to the overall proof, but we want point out that the polyhedra involved in the proof are very highly structured.";

        S=S+"\nPoint B is the origin.";
	S=S+"\n\nThe orthoschemes T(a,b)=ABCD and T(a,c)=ABEF are rotated so that there are 3 planes through B, each containing a face of both ABCD and ABEF.";
	S=S+"\n\nThe points B,C,D,E,F,G are coplanar.";
	S=S+"\n\nThe point A,C,D,E,F,K,L,M all lie on a sphere centered at H.";
	S=S+"\n\nI is the projection of H to the plane containing A,B,C,F,L";
	S=S+"\n\nJ is the projection of H to the plane containing A,B,D,E,M";
	S=S+"\n\n, Each triple DGF, AHK, AIL, AJM consists of evenly spaced collinear points.";
	S=S+"\n\n Points N and O lie on edges of pseudoprisms P4 and P6.";
	S=S+"\n\nClicking on various special projections and turning on the relevant points will make the claims more clear.";



	S=S+"\n\nVIEWING:\n\n";
	S=S+"You can change the point of view on the black control panelby clicking in the black annulus.  The dot essentially places the eye of the observer on a sphere that surrounds the polyhedra.  As you move around the annulus you circulate around the polyhedra. As you move inward, you are moving the eye upwards on the sphere.  Some additional features:\n\nYou can push the green button to do animation.\nYou can change the transparency of the polyhedra.\nYou can change the speed of the animation.\nYou can move the observer to special locations by clicking on the special projections button.\nYou can recolor the polyhedra using the color selector.";

	S=S+"\n\nEXPORT\n\n";
	S=S+"You can export the polyhedra either as .stl files or .obj files.  You can choose a new file name by typing something in the field that initially says 'file'.  The files are stored in the subdirecory Export.  If there are (say) 3 polyhedra lit up and you use the .stl option which makes 1 file per polyhedron, then your files will appear as file0.stl, file1.stl, file2.stl.  Push the green export button when you are ready to export.  ";

	
	D.setExplain(S);
    }






    
    public static void keyControls(DocumentCanvas D) {
	String S="Keyboard commands:\n\nGENERAL:  \n\n (z) mouse button 1\n (x) mouse button 2\n(c) mouse button 3.\n\n";
		S=S+"POLYGON WINDOW: \n\n(a) add vertex to polygon \n(d) delete vertex\n\n";

	try{
        D.setExplain(S);
	}
	catch(Exception e) {}
    }

    public static void polyWindow(DocumentCanvas D) {
	String S="Polygon Window:\n\nThis controls the features in the polygon control window (SelectWindow.java).";

	S=S+"\n\nbackground: Controls the background color.";
	S=S+"\n\npoly fill: Controls the color of the polygon.";
	S=S+"\n\npoly edges: Controls the color of the polygon edges.";
	S=S+"\n\ninflection edges: the polygon edges which are the middle of a zigzag.";
	S=S+"\n\ncone: This is the cone made from two edges incident to a vertex.  The cone is the colored part. This is how we compute the boundary of the inflection surface. Generically, the boundary consists of pairs v,w where v is a vertex and w is another point of the polygon contained inside the cone at v.";
	S=S+"\n\nsides 1,2,3: The space of triangles inscribed in the polygon has a tiling by rectangular solids.  Each tile is the product of 3 edges.  The incidence surface, consisting of the degenerate triangles, naturally is adapted to this tiling.  We compute this surface by intersecting it with the tiles and computing each intersection separately. The polygon window keeps track of one tile at a time, which is to say a triple of edges.";
	S=S+"\n\nvertex: controls the color of the highlighted vertex.";
	S=S+"\n\ncode chord: Each vertex of the incidence surface corresponds to a line which goes through 2 vertices of the polygon and has a third point on an edge of the polygon.  This feature draws this line, or rather the minimal chord containing all 3 points.  The code associated to the chord is the list of the 2 vertex indices and the edge index.  On the surface window display, the two vertex indices are drawn in white and the edge index is drawn in black.";
	

	try{
        D.setExplain(S);
	}
	catch(Exception e) {}
    }




}

