import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Polyhedron {
    Vector[] V=new Vector[10];
    int[][] facet=new int[10][10];
    int length;
    Color FILL,OUTLINE;

    public Polyhedron() {

	for(int i=0;i<10;++i) {
	    for(int j=0;j<10;++j) {
		facet[i][j]=-1;
	    }
	}

    }

    public Polyhedron(Polyhedron T) {
	for(int i=0;i<T.length;++i) this.V[i]=new Vector(T.V[i]);
	this.FILL=T.FILL;
	this.OUTLINE=T.OUTLINE;
	this.length=T.length;
	for(int i=0;i<10;++i) {
	    for(int j=0;j<10;++j) {
		this.facet[i][j]=T.facet[i][j];
	    }
	}
    }



    //basic orthoscheme

    public static Polyhedron ortho(double a,double b) {
	Polyhedron T=new Polyhedron();
	double ca=Math.sqrt((1/a)-1);
	double cb=Math.sqrt((1/b)-1);
	T.V[0]=new Vector(0,0,0);
	T.V[1]=new Vector(ca,0,0);
	T.V[2]=new Vector(ca,ca*cb,0);
	T.V[3]=new Vector(ca,ca*cb,cb);
	return(T);
    }

    public double sideLength(int i,int j) {
	double d=Vector.dist(this.V[i],this.V[j]);
	return(d);
    }


    public double convert1(double x) {
	double y=Math.sin(2*Math.PI*x);
	y=y*y;
	return(y);
    }

    public double convert2(double x) {
	double y=Math.sin(Math.PI/2-2*Math.PI*x);
	y=y*y;
	return(y);
    }

    public void printDist() {
	for(int i=0;i<length;++i) {
	    for(int j=i+1;j<length;++j) {
		double d=Vector.dist(V[i],V[j]);
		System.out.println(i+" "+j+"   "+d);
	    }
	}
    }


    public double tetDet() {
	Vector[] W=new Vector[3];
	W[0]=Vector.minus(V[1],V[0]);
	W[1]=Vector.minus(V[2],V[0]);
	W[2]=Vector.minus(V[3],V[0]);
	Matrix m=new Matrix();
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		m.a[i][j]=W[i].x[j];
	    }
	}
	return(m.det());
    }



    //used for rotating prisms
    public static Polyhedron specialRotate(Polyhedron P) {
	Polyhedron Q=new Polyhedron(P);
	Vector V1=P.V[4];
	Vector V2=Vector.average(P.V[0],P.V[3]);
	Vector V3=Vector.minus(V1,V2);
	for(int i=0;i<5;++i) {
	    Q.V[i]=Vector.rotate(V2,V3,P.V[i]);
	}
	return(Q);
    }

    //center of mass
    public Vector center() {
	Vector W=new Vector(0,0,0);
	for(int i=0;i<length;++i) W=Vector.plus(W,V[i]);
	for(int i=0;i<3;++i) W.x[i]=W.x[i]/length;
	return W;
    }

    //retract about center of mass
    public Polyhedron retract(double t) {
	Polyhedron Q=new Polyhedron(this);
	Vector W=this.center();
	for(int i=0;i<Q.length;++i) {
	    Q.V[i]=Vector.interpolate(W,Q.V[i],t);
	}
	return Q;
    }
    

    public void print() {
	System.out.println("vec # "+length);
	for(int i=0;i<length;++i) V[i].print();
	int num=facet[0][0];
	for(int i=1;i<num+1;++i) {
	    for(int j=1;j<facet[i][0]+1;++j) {
		System.out.print(facet[i][j]+" ");
	    }
	    System.out.println("");
	}
    }


    public void print2() {
	System.out.println("vec # "+length);
	for(int i=0;i<length;++i) V[i].print();
    }




}

