import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class TempCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;
    Facet F1,F2;


     public TempCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(100,300,50);	
	 initFacets();
     }

    public void initFacets() {
	F1=new Facet(new Complex(1.99156,1.63299),new Complex(.99578,1.31649),new Complex(.57735,0));
	F2=new Facet(new Complex(.57735,0),new Complex(1.99156,1.63299),new Complex(.57735,1.63299));

    }


    public TempCanvas addManager(Manager M) {
	TempCanvas PP=this;
	PP.M=M;
	return(PP);
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(Color.white);
      g.fillRect(0,0,getWidth(),getHeight());
      drawFacets(g);
   }


    public void drawFacets(Graphics2D g) {

	GeneralPath gp1=F1.toPath();
	GeneralPath gp2=F2.toPath();
	gp1=transform(gp1);
	gp2=transform(gp2);
	g.setColor(new Color(255,0,0,150));
	g.fill(gp1);

	g.setColor(new Color(0,0,255,150));
	g.fill(gp2);
	g.setColor(Color.black);
	g.draw(gp1);
	g.draw(gp2);

	g.setColor(new Color(130,0,0));
	int test=Facet.testDisjoint(F1,F2);
	if(test==1) g.setColor(Color.green);
	g.fillRect(0,0,30,30);

	if(test==0) {
	    Complex z=Facet.goodIntersection(F1,F2);
	    drawCross(g,z);
	}
    }


    public void drawCross(Graphics2D g,Complex z) {
	GeneralPath gp=new GeneralPath();
            gp.moveTo(-10,(float)(z.y));
	    gp.lineTo( 10,(float)(z.y));
	    gp.moveTo((float)(z.x),-10);
	    gp.lineTo((float)(z.x),10);
	    g.setColor(Color.black);
	    gp=transform(gp);
	    g.draw(gp);


    }



    public void dragFacet() {
	double min=100;
	int test=-1;
	for(int i=0;i<3;++i) {
	    double d=Complex.dist(SOURCE,F1.z[i]);
	    if(d<min) {
		min=d;
		test=i;
	    }
	}
	for(int i=0;i<3;++i) {
	    double d=Complex.dist(SOURCE,F2.z[i]);
	    if(d<min) {
		min=d;
		test=i+3;
	    }
	}

	if(test<3) F1.z[test]=new Complex(SOURCE);
	if(test>=3) F2.z[test-3]=new Complex(SOURCE);
    }





    public void mousePressed(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	int mode=J.mode;
        if(mode==1) scaleUp(J.X,-1);
        if(mode==3) scaleUp(J.X,+1);
	if(mode==2) SOURCE=unTransform(J.X);
	repaint();
    }



     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	int mode=J.mode;
	 if(mode==2) {
              SOURCE=unTransform(J.X);
	      dragFacet();
	 }
	 repaint();

     }


}

